;V7.2_2.56_16    0,8 
;    PB5,     0  5 ,    +40  Iz

;      50      8 
;  LCD 1602   %   1%(254)
.include "m8def.inc"

.def	A1	=	r16
.def	A2	=	r17
.def	D1	=	r22
.def	D2	=	r23
.def	OA1	=	r24
.def	OA2	=	r25
.def 	XL	=	r26

.def	vol_A_z	=	r10
.def	vol_A_ADC	=	r9	; 1     I  Iz

.def	kalibr		=	r11	;  FF -   00 -   
.def	sum_IL	 	=	r12
.def	sum_IH		=	r13

.def	const_V		=	r14
.def	const_I		=	r15

.def	buf			=	R16	;General use working register buf for calling subroutines
.def	return		=	r16	;return value from subroutines
.def	temp		=	r17
.def	cnt			=	r18
;.def	flags		=	r19
.def	vol_A		=	r20	;0-20   0  950 m
.def	vol_V		=	r21	;2-80   2  16 
.def	buf2		=	r22
.def	speed		=	r27
.def	cnt_ind		=	r28	;   0,8    
.def	pause_w		=	r29	;    vol_V vol_A  EEPROM
;------------------------------
.equ	LCD_RS	= 2
.equ	LCD_RW	= 1
.equ	LCD_E	= 3  
.equ	line1   =0x80		; 1 LCD
.equ	line2   =0xC0		; 2 LCD 
.equ	sek_5=50	; eeprom   5     V I
;  sbrc  sbr
;r20.0  $1  	; 1-   0-
;r20.1  $2  	; 1-   0-  
;r20.2  $4  	; 1-  
;r20.3  $8  	; 1- 
;r20.4  $10 	; 1- 
;r20.5  $20 	; 1- 
;r20.6  $40	    ; 1- 
;r20.7  $80 	; 1-    pB0
;-------------------------------------------------------------
.cseg
 rjmp RESET ; Reset Handler
 reti ;EXT_INT0 ; IRQ0 Handler
 reti ;EXT_INT1 ; IRQ1 Handler
 reti ;TIM2_COMP ; Timer2 Compare Handler
 reti ;TIM2_OVF ; Timer2 Overflow Handler
 reti ;TIM1_CAPT ; Timer1 Capture Handler
 rjmp T1;reti ;TIM1_COMPA ; Timer1 CompareA Handler
 reti ;TIM1_COMPB ; Timer1 CompareB Handler
 reti ;TIM1_OVF ; Timer1 Overflow Handler
 reti ;TIM0_OVF ; Timer0 Overflow Handler
 reti ;SPI_STC ; SPI Transfer Complete Handler
 reti ;USART_RXC ; USART RX Complete Handler
 reti ;USART_UDRE ; UDR Empty Handler
 reti ;USART_TXC ; USART TX Complete Handler
 reti ;ADC ; ADC Conversion Complete Handler
 reti ;EE_RDY ; EEPROM Ready Handler
 reti ;ANA_COMP ; Analog Comparator Handler
 reti ;TWSI ; Two-wire Serial Interface 
 reti ;SPM_RDY ; Store Program Memory Ready RESET:
RESET:
	ldi r16,high(RAMEND); Main program start
	out SPH,r16 ; Set Stack Pointer to top of RAM
	ldi r16,low(RAMEND)
	out SPL,r16
;-----------------------------------------------------------------------
	ldi R16,0B00010000  	;      T1 
	out timsk,r16			; 
	ldi R16,0b00000000
	out tccr1a,r16	
	ldi R16,0B00001101 		; T1   ,	 1024  100  
	out tccr1b,r16	
;     
	ldi r30,$03
	ldi r31,$0d
	out ocr1ah,r30
	out ocr1al,r31
;T2 fast PWM
	ldi r16,0b01111001	    ;T2  fast PWM, ()  ,   1 ###
	out TCCR2,r16
; ADC
	ldi buf,0b10000110	;101 f/32, 110 f/64, 111  f/128,     5
	out adcsra,buf
;	ldi buf,0b00100000	; (00 5v, 11 2,56v  7,6) -5; 5 1   ,  3-0 
;	out admux,buf
;   B
	ldi R16,0B11001000		; 
	out DDRB,R16	
	ldi R16,0B11111111
	out portB,r16        	;   c 
;   C
	ldi R16,0B11111100		; 
	out DDRC,R16	
	ldi R16,0B11111100
	out portC,r16        	;   c 
;   D LCD
;  
;  $60 
 	ldi	ZH,high(2*str1)	;      
	ldi	ZL,low(2*str1)	;
	ldi	YH,0
	ldi	YL,$60
	rcall in_ram	
;  $80 
 	ldi	ZH,high(2*str2)	;      
	ldi	ZL,low(2*str2)	;
	ldi	YH,0
	ldi	YL,$80
	rcall in_ram
; 
; vol_V -00h, vol_A - 01h
;  korr   00 eeprom
	clr buf				;  buf     
	out eearh,buf
	rcall r_eeprom		; ,   buf
	mov vol_V,buf	
	ldi buf,1				;  buf     
	rcall r_eeprom		; ,   buf
	mov vol_A,buf	
;     V  I
	ldi buf,2			;  buf     
	rcall r_eeprom		; ,   buf
	mov const_V,buf	
	ldi buf,3			;  buf     
	rcall r_eeprom		; ,   buf
	mov const_I,buf	
	
	clt		;	   EEPROM  (1 )
	ldi r16,254	;  1%
	mov kalibr,r16
	out ocr2,r16
	ldi pause_w,sek_5 ; 5     EEPROM
	ldi cnt_ind,8	;0.8 sek
	clr speed

	rcall	longdelay		;500 msec;###
	rcall	LCD_init
	sei
rep:

	rjmp rep
;===================
T1:	;  100 
; 
	rcall kalib_W
	rcall V_I_EE
	rcall acp_V
	rcall acp_I
;	rcall num_V
;	rcall num_A
	rcall cmp_V_I	;    $60 $80
;   
	in buf,pinB
	andi buf,0b00010111
	cpi buf,$17
	breq na_cl

	ldi pause_w,sek_5

	cpi buf,5
	breq eqq
	cpi buf,6
	breq eqq
	cpi buf,$11
	breq eqq
	cpi buf,$12
	breq eqq
na_cl:
	clr speed
;===============================
	rjmp na_lcd
;==========================
eqq:
	set	;     EEPROM        5 

	inc speed
	cpi speed,26
	brsh na_knop
	cpi speed,5
	breq kno
	cpi speed,10
	breq kno
	cpi speed,15
	breq kno
	cpi speed,20
	breq kno
	rjmp na_lcd
na_knop:
	ldi speed,40
kno:
;=========================	
	rcall knop

;  $60   $80   LCD 
na_lcd:
;  LCD         ;###
	tst speed
	brne na_ind	;    ###
	dec cnt_ind	;  
	breq na_ind
	reti	
na_ind:
	rcall num_V
	rcall num_A
	ldi cnt_ind,8	;0,8 sek
	clr r31
	ldi r30,$60
	rcall in_lcd1
	clr r31
	ldi r30,$80
	rcall in_lcd2 
	reti
;===============================================
in_lcd1:
	ldi	buf, line1 ; 
	rcall	LCD_command
	clr cnt
elc1:
;    CNT
	inc cnt
;	mov buf,cnt
	cpi cnt,17
	breq renc1
	ld buf,z+
	rcall	LCD_putchar
	rjmp	elc1
renc1:	;       
	ret
in_lcd2:
	ldi	buf, line2 ; 
	rcall	LCD_command
	clr cnt
elc:
;    CNT
	inc cnt
;	mov buf,cnt
	cpi cnt,17
	breq renc
	ld buf,z+
	rcall	LCD_putchar
	rjmp	elc
renc:	;       
	ret
;-----------------
V_I_EE:
;  
	brtc no_write
	dec pause_w
	brne no_nul
;	ldi pause_w,sek_5

;   vol_V   00h    vol_A   01h
	clr buf
	out eearl,buf	;    
	out eearh,buf	;    
	out eedr,vol_V		;  buf   
;   EEPROM
	rcall w_eeprom
	nop

	ldi buf,1
	out eearl,buf	;    
;	out eearh,buf	;    
	out eedr,vol_A		;  buf   
;   EEPROM
	rcall w_eeprom
	clt
no_nul:
no_write:
	ret
;====================================
acp_V:
		ldi buf,0b11100000	; 00 5v, 11 2,56v -5; 5 1   ,  3-0 
		out admux,buf
		sbi adcsra,adsc

		sbis adcsra,adif
		rjmp PC-1
;		in H0,ADCL; //   ADC
		in r16,ADCH
		mov r17,const_V
	 	mul r16,r17          ; r1:r0 = r17 * r16
        movw r17:r16,r1:r0   ; 
		ldi D1,$C4;10	;09c4h = 2500  2,56  5 
		ldi D2,$09;27
		rcall S_Div_WordWord	;   A1 

		cpi A1,20
		brsh bo_20

		cpi A1,10
		brlo mense_10
		subi A1,10
		ldi buf2,$30
		add buf2,A1
		sts $63,buf2	;A1
		ldi buf2,$31
		sts $62,buf2	;1
		rjmp j1
mense_10:
		ldi buf2,$30
		add A1,buf2		;A1
		sts $63,A1
		ldi buf2,$30	;0
		sts $62,buf2
j1:
;   100
		mov A2,OA2
		mov A1,OA1

		clr d2
		ldi d1,25;100
		rcall S_Div_WordWord	;   A1   BUF    (3,99)

	rcall bin8tobcd	;>A2 A1
	ldi buf2,$30	
;--------------------------
;   A2=9 A1=8
	cpi A1,5
	brlo no_okrugl
	cpi A2,9
	brne no_9
	clr A2
	lds buf,$63	; 
	cpi buf,$39
	breq y_9
	inc buf
	sts $63,buf
	rjmp no_40
y_9:
	ldi buf,$30
	sts $63,buf
	lds buf,$62	; 
	inc buf
	sts $62,buf

	cpi buf,$32
	brne no_40
bo_20:
		ldi buf,'H'
		sts $62,buf
		ldi buf,'i'
		sts $63,buf	 
		ldi buf,' ' 
		sts $65,buf 
		ret
no_9:
	inc A2
no_40:
no_okrugl:
;------------------------
	add A2,buf2
	sts $65,A2
	ret
acp_I:
		ldi buf,0b11100001	; 00 5v, 11 2,56v -5; 5 1   ,  3-0 
		out admux,buf
		sbi adcsra,adsc

		sbis adcsra,adif
		rjmp PC-1
;		in H0,ADCL; //   ADC
		in buf,ADCH


		mov r17,const_I;100
	 	mul r16,r17          ; r1:r0 = r17 * r16
        movw r17:r16,r1:r0   ; 
		ldi D1,200	;200  2,56, 204  5
		clr D2		;0
		rcall S_Div_WordWord	;   A2 A1 OA2 OA1  0-999

;*******    8 **********
		add sum_IL,A1	;   cnt_ind  
		clr buf2
		adc sum_IH,buf2
		cpi cnt_ind,1


		brne no_sum
		lsr sum_IH
		ror sum_IL
		lsr sum_IH
		ror sum_IL
		lsr sum_IH
		ror sum_IL
		mov A1,sum_IL
		clr sum_IL
		clr sum_IH
no_sum:

;*************************************

		mov vol_A_ADC,A1
		cpi A1,100
		brlo men_100

		ldi buf,'H'
		sts $82,buf
		ldi buf,'i'
		sts $83,buf	
		ldi buf,' '  
		sts $84,buf
		ret

men_100:
;Input:  r16 - 8bit Binary
;Output: r18:r17:r16 unpacked BCD
		rcall bin8tobcd	;>A2 A1
		ldi buf2,$30
		add r17,buf2
		sts $82,r17	  
		add r16,buf2
		sts $83,r16 
;
		cpi OA1,90
		brlo men_pol
		ldi buf,$35
		sts $84,buf	;A1
		ret
men_pol:
		ldi buf,$30
		sts $84,buf	;A1

		RET
cmp_V_I:
;V izm 64 65, 67 
;V zad 72 73, 75
	lds D1,$62
	lds D2,$6B;72
	cp D1,D2
	brlo men1		;izm < zad
;  
	brne ne_ravno
;
	lds D1,$63
	lds D2,$6C;73
	cp D1,D2
	brlo men1
	brne ne_ravno
	lds D1,$65
	lds D2,$6E;75
	cp D1,D2
	brlo men1
ne_ravno:	
	cbi portC,5	;svetod ON   
;-----------------------
;   
	in r16,ocr2
	inc r16
	brne no_0V
	ldi r16,253;
no_0V:
	out ocr2,r16
;----------------------
	rjmp na_tok
men1:
	sbi portC,5	;svetod OFF
;===============================
na_tok:
	
	;   0,8      
	cpi cnt_ind,1
	brne bbb
	mov buf,vol_A_z
	ldi buf2,5		;5- +-50mA
	add buf,buf2
	cp vol_A_ADC,buf

	brlo bbb
	ser r16		;      50     
	out ocr2,r16
	ret
bbb:

;    +- 10  

	mov buf,vol_A_z
	inc buf
	cp vol_A_ADC,buf	;z>adc
	brsh b1
	mov buf,vol_A_z
	dec buf
	cp vol_A_ADC,buf
	brlo b1
	rjmp svetod_off

b1:
	cp vol_A_z,vol_A_ADC
	brlo menshe
;  
	sbis portC,5	;  
	rjmp svetod_off ;  

;    ocr   
	cbi portC,4	;svetod ON
	in r16,ocr2
	dec r16
	cpi r16,255
	brne no_255
	clr r16
no_255:
	out ocr2,r16
	ret
menshe:	
;         
	sbis portC,5
	rjmp svetod_off ;  

;    ocr   
;	cbi portC,4	;svetod ON
	sbi portC,4	;svetod OFF
	in r16,ocr2
	inc r16
	tst r16
	brne no_0
	ldi r16,253;127;ser r16
no_0:
	out ocr2,r16
	ret
;      portC,4 ocr  
svetod_off:
	sbi portC,4	;svetod OFF
	ret

; ------------------------------------------------------------------------------
;     (16 / 16 -> 16.16) ////////////////////////////////////
; ------------------------------------------------------------------------------
; --> A1, A2 --  .  . 
;     D1, D2 --  .  . 
; <-- A1, A2 --  .  . 
;     OA1, OA2 --  .  . 
; : A1, A2, OA1, OA2, XL
S_Div_WordWord:
    ldi        XL, 17                    ;   +  C
    clr        OA1                   ;  .
    clr        OA2                   ;  .
    clc
S_Div_WordWord_Loop:
    rol        OA1
    rol        OA2
    sub        OA1, D1
    sbc        OA2, D2
    brcc    S_Div_WordWord_1
        add        OA1, D1
        adc        OA2, D2
S_Div_WordWord_1:
    rol        A1
    rol        A2
    dec        XL
    brne    S_Div_WordWord_Loop
    com        A1
    com        A2
    ret
;==============================================
in_ram:	;    Z    Y
el:
		lpm	; 
		tst	r0		; Check if we've reached the end of the message
		breq ren
		st y+,r0	; 
		adiw	ZL,1		; Increase Z registers
		rjmp	el
ren:	;       
		ret
;===============================================================
knop:
;  -------------------------
	sbic pinB,2	;V
	rjmp no_V
; UP Down 
	sbic pinB,0	;UP
	rjmp no_UP

; 
	sbis pinB,5	;kalibr
	rjmp na_kalibr1
;------------------
	inc vol_V
	cpi vol_v,160;80
	brlo no_16
	ldi vol_v,1
no_16:
	ret
;------------
na_kalibr1:
	inc const_V
	clr kalibr
	ret

no_UP:
; Down
	sbic pinB,1	;DOWN
	ret

; 
	sbis pinB,5	;kalibr
	rjmp na_kalibr
;-----------------
	dec vol_V
;	tst vol_V
	breq y_0
	ret
;----------------
na_kalibr:
	dec const_V
	clr kalibr
	ret

y_0:
	ldi vol_v,160;80
	ret
no_V:
;   
	sbic pinB,4	;A
	ret	;  	
; UP Down 
	sbic pinB,0	;UP
	rjmp no_UP_A
;------------------------
; 
	sbis pinB,5	;kalibr
	rjmp na_kalibr2
;-----------------
	inc vol_A
	cpi vol_A,19
	brlo no_20
	clr vol_A
no_20:
na_ret:
	ret
;----------------
na_kalibr2:
	inc const_I
	clr kalibr
	ret
no_UP_A:
; Down A
	sbic pinB,1	;DOWN
	ret
;------------------------
; 
	sbis pinB,5	;kalibr
	rjmp na_kalibr3
;-----------------
	dec vol_A
	cpi vol_A,19
	brlo na_ret
	ldi vol_A,18
	ret
;----------------
na_kalibr3:
	dec const_I
	clr kalibr
	ret
;  BCD ASCII   
num_V:
	nop
	mov buf,vol_V
;	lsl buf		;  2
	rcall bin8tobcd
	ldi buf2,$30
	add r18,buf2
	sts $6B,r18
	add r17,buf2
	sts $6C,r17
	add r16,buf2
	sts $6E,r16
	ret
num_A:
	mov buf,vol_A
	clr r0
	ldi	zh,High(2*text_A)
	ldi	zl,Low(2*text_A)

	add zl,buf
	clr buf
	adc zh,buf
	lpm					
	mov buf,r0
	mov vol_A_z,buf
	rcall bin8tobcd
	ldi buf2,$30
	add r17,buf2
	sts $8B,r17
	add r16,buf2
	sts $8C,r16
	ret
;=================================================
longdelay:
		ldi	r30,30	;
		ldi	r31,255	;
puwait:
		rcall	delay
		dec	r30
		brne	puwait
		ret
delay:	
		ldi 	r16,64	
cagain:		dec	r16
		nop
		brne 	cagain
		dec 	r31
		brne 	delay
		ret
;Input:  r16 - 8bit Binary
;Output: r18:r17:r16 unpacked BCD
bin8tobcd:
    ldi     r17,164
    mul     r16,r17
    clr     r18
    lsl     r0
    rol     r1
    rol     r18
    lsl     r0
    rol     r1
    rol     r18
    inc     r1
    ldi     r16,10
    mul     r1,r16
    mov     r17,r1
    mul     r0,r16
    mov     r16,r1
ret
; /  EEPROM	 buf
r_eeprom:	
	out eearl,buf
	sbi eecr,eere
	in buf,eedr
no_s_eere:	
	sbic eecr,eere
	rjmp no_s_eere	
	ret
; /   eeprom 
w_eeprom:
;	out eedr,buf		;  buf   
	sbi eecr,eemwe
	sbi eecr,eewe
no_s_eewe:	
	sbic eecr,eewe
	rjmp no_s_eewe
	nop
	ret
;    EEPROM $02-V $03-I
kalib_W:
	sbis pinB,5	;kalibr
	rjmp naa_rett
	tst kalibr
	brne naa_rett	;  
;   vol_V   00h    vol_A   01h
	clr buf
	out eearh,buf	;    
	ldi buf,$02
	out eearl,buf	;    
	out eedr,const_V		;  buf   
;   EEPROM
	rcall w_eeprom
	nop

	ldi buf,$03
	mov kalibr,buf
	out eearl,buf	;    
;	out eearh,buf	;    
	out eedr,const_I		;  buf   
;   EEPROM
	rcall w_eeprom
naa_rett:
	ret

.include "lcd_do8M.asm"

;-----------------------------------------------
str1:                ;		 ;	
.db "U=14,3B Uz=12,4B",0
str2:
.db "I=345mA Iz=970mA",0 ;System - ONF

;.db "I=345mA Iz=970mA 99% 999",0 ;System - ONF


text_A:
.db 5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95
;.EXIT







